; Patch by Conn
; apply on Secret of Mana2/Seijen Densetsu 3 without header

; header ; remove selection before "header" if your rom has a header

; $7eae00: track number
; $7eae01: msu busy flag (01- track to be played)
; $7eae02: volume
; $7eae03: new track has been introduced  
; $7eae04: return to music after inn/level up 
; &7e1c10: Debuggerram
hirom

;----------------hooks

org $C50212
	JSL trackChange3 ; mana holyland call dragon
	

org $C502ED
    JSL trackChange2

org $C50378 ;Introduce new track
	JSL trackChange

org $C507CC ;play commands 
	JSL playCommands
	NOP

org $fd89f8
	JSL irqHook ;irq
org $fd80cf
	JSL irqHook ;nmi
org $c033AE
	JSL irqHook2 ;irq2

org $C503B1
	JML fadeCommand
	NOP	

org $C5029A
	JSL security
	NOP

org $C4ABB9
	LDA $7eae00 ; stores track number into safe file so you continue with music
org $c43a5d	
	LDA $7eae00 ; something similar... prevent bug I guess to change this to msu

;----------------- freespace
org $effe50 
trackChange:
	LDA $01
	STA $10
	TC3:     ;hook for trackChange3
	STA $7eae00
	CMP #$00
	BNE $05
	STZ $2006
	BRA muteSPC
	STA $2004
	STZ $2005
	LDA #$01
	STA $7eae03 ; new track has been introduced
	muteSPC:
	LDA #$00  ; mute spc
	STA $10
	RTL

trackChange2: ; for inn, level up continue
	LDA $08
	STA $10	
	LDA $7eae04
	CMP #$00
	BNE $05
	STZ $2006
	BRA muteSPC2
	STA $2004
	STA $7eae00
	STZ $2005
	LDA #$01
	STA $7eae03 ; new track has been introduced
	muteSPC2:
	LDA #$00  ; mute spc
	STA $10
	RTL	

trackChange3: ; for mana holyland	
	LDX $01
	STX $10
	PHA
	PHX
	TXA
	XBA
	LDA #$00
	XBA
	JSL TC3
	PLX
	PLA
	RTL
	
	
playCommands:
	LDA $02
	STA $2142
	CMP #$7F ; Play command
	BNE $06
	LDA #$01
	STA $7eae01 ; track can be played
	CMP #$00
	BNE nofade
	LDA $1C3F
	cmp #$13
	BNE nofade
	LDA #$02
	STA $7eae01
	nofade:
	RTL 	

	
irqHook:
	LDA #$0000
	SEP #$20
	ih2:
	LDA $7eae01
	CMP #$01
	BEQ playTrack
	CMP #$02
	BEQ fade
	endIRQ:
	LDA #$00
	RTL

	playTrack:
	LDA $7eae00
	CMP #$00
	BEQ endIRQ
	LDA $7eae03
	CMP #$01
	BNE endIRQ	
	Bit $2000 
	BVS endIRQ
	LDA $7eae00
	PHX
	TAX
	LDA $efffb0,x
	cmp #$03
	BNE noInn ; no inn or levelup
	LDA $7eae00
	cmp #$36 ; canon
	BEQ exception
	cmp #$41 ; level up
	BEQ exception
	cmp #$2E ; Fairy inside you
	BEQ exception	
	STA $7eae04 ; if loop track save for inn later
	exception: ;don't save for continue
	LDA #$03
	noInn:
	PLX
	STA $2007
	LDA #$FF
	STA $2006
	STA $7eae02
	LDA #$00
	STA $7eae03 ; clear introduced flag
	BRA endIRQ

fade:
	LDA $7eae02
	CMP #$00
	BEQ mutefade
	dec
	dec
	dec
	STA $7eae02
	STA $2006
	cmp #$05
	bcc mutefade
	Bra endIRQ
	mutefade:
	STZ $2006
	LDA #$00
	STA $7eae02
	STA $7eae01
	bra endIRQ

irqHook2:
	LDA #$2100
	TCD
	LDA #$0000
	SEP #$20
	PHB
	LDA #$00
	PHA
	PLB
	JSL ih2
	PLB
	RTL
	
fadeCommand:  	
	LDA $2142
	BEQ $04
	JML $C503B6  ; fade
	JML $C503CE  ; no fade
	
security:
	LDA #$04
	STA $2140
	LDA $7eae03
	CMP #$01
	BEQ $01
	RTL
	LDA #$01
	STA $7eae01
	RTL
 
	
;----------------- looptable

ORG $efffb0 ; loop table 03:loop, 01 non-loop
;   0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
db $01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 00-0f  
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01,$03,$03,$03,$03 ; themes 10-1f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01,$03,$03,$03,$03 ; themes 20-2f 
db $03,$03,$03,$03,$03,$03,$03,$01,$01,$03,$03,$03,$03,$01,$03,$03 ; themes 30-3f 
db $03,$03,$01,$03,$01,$01,$03,$03,$01,$01,$01,$03,$03,$03,$03,$03 ; themes 40-4f 
